#ifndef __MEM_H__
#define __MEM_H__

#include "global.h"

void *malloc(int size);
uint32 textureMalloc(uint32 size);
int allocateMem();
void textureSetup();
void clearBitmaps();
void loadRom(byte *from, byte *to, int start, int end);
void loadGame();
unsigned Z80_RDMEM(dword A);
void Z80_WRMEM(dword A, byte V);

#endif /* __MEM_H__ */