#include "strqueues.h"

void doPrestore(uint32 addr)
{
	asm("pref @r4");
}

void sqmemcpy(void *dest, void *src)
{
	int i,j;
	volatile unsigned long *regs = (unsigned long *)0xff000038;
	unsigned long formattedAddr;
	uint32 *pSQ;

	regs[0] = regs[1] = ((unsigned long)dest >> 24);
	pSQ = ((uint32*) 0xe0000000);
  
	formattedAddr = 0xe0000000 | (((unsigned long)dest) &= 0x03FFFFFF);
  
	for (i = 0; i < 13; i++)
	{
		if ((i % 2) == 0)
		{			/* SQ0 */
			for (j = 0; j < 8; j++)
			{
				pSQ[j] = ((uint32 *)src)[(i*8) + j];
			}
			doPrestore(formattedAddr);
		}
		else
		{			/* SQ1 */
			for (j = 0; j < 8; j++)
			{
				pSQ[j + 8] = ((uint32 *)src)[(i*8) + j];
			}
			doPrestore(formattedAddr);
		}
		formattedAddr += 32;
	}
}