#ifndef __PALETTE_H__
#define __PALETTE_H__

#define RGB565(r, g, b) ((r >> 3) << 11)| ((g >> 2) << 5)| ((b >> 3) << 0)

int phoenixPalette1[] = {
        
        // CharA

        RGB565(0x00,0x00,0x00), // black
        RGB565(0x00,0x00,0x00), // black
        RGB565(0x00,0xDF,0x35), // greenish (This is the text)
        RGB565(0x00,0xFF,0xDB), // cyan
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0xFF,0x00,0x00), // red
        RGB565(0xDB,0xDB,0xDB), // white
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0xFF,0x00,0x00), // red
        RGB565(0xDB,0xDB,0xDB), // white
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xB6,0xDB), // pink
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xB6,0xDB), // pink
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xB6,0xDB), // pink
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xDB,0xDB,0xDB), // white
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0xDB,0xDB,0xDB), // white

        // CharB        

        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0x00), // red
        RGB565(0x24,0x24,0xDB), // blue
        RGB565(0xDB,0xDB,0xDB), // white
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0xFF,0xB6,0x00), // dark orange
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xB6,0x24,0xFF), // dark purple
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0xFF,0xB6,0x00), // dark orange
        RGB565(0x00,0x00,0x00), // black
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0xB6,0x24,0xFF), // dark purple
        RGB565(0xFF,0x24,0xB6), // light purple
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0x00,0xFF,0x00), // green
};

int phoenixPalette2[] = {
        
        // CharA

        RGB565(0x00,0x00,0x00), // black
        RGB565(0x00,0x00,0x00), // black
        RGB565(0x00,0xFF,0xDB), // cyan
        RGB565(0x00,0xFF,0xDB), // cyan
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0xFF,0x00,0x00), // red
        RGB565(0xDB,0xDB,0xDB), // white
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0xFF,0x00,0x00), // red
        RGB565(0xDB,0xDB,0xDB), // white
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0x00,0xFF,0x00), // green                
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0xFF,0x00), // yellow
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xDB,0xDB,0xDB), // white
        RGB565(0xFF,0x00,0x00), // red
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0xDB,0xDB,0xDB), // white

        // CharB

        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0x00), // red
        RGB565(0x24,0x24,0xDB), // blue
        RGB565(0xDB,0xDB,0xDB), // white
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xFF,0x00,0xFF), // purple
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0xFF,0xB6,0x00), // dark orange
        RGB565(0x00,0x00,0x00), // black
        RGB565(0xB6,0x24,0xFF), // dark purple
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0xFF,0xB6,0x00), // dark orange
        RGB565(0x00,0x00,0x00), // black
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0xB6,0x24,0xFF), // dark purple
        RGB565(0xFF,0x24,0xB6), // light purple
        RGB565(0x00,0x00,0x00), // black
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0xFF,0x24,0xB6), // light purple
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0x00,0x00,0x00), // black
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0xFF,0x24,0xB6), // light purple
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0x00,0x00,0x00), // black
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0xFF,0x24,0xB6), // light purple
        RGB565(0x00,0xFF,0x00), // green
        RGB565(0x00,0x00,0x00), // black
        RGB565(0x95,0x95,0xFF), // blueish
        RGB565(0xFF,0x24,0xB6), // light purple
        RGB565(0x00,0xFF,0x00), // green
};                                

#endif __PALETTE_H__